"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var platform_browser_1 = require("@angular/platform-browser");
var event_manager_plugin_1 = require("../__util/event-manager-plugin");
/**
 * Listen to events without triggering change detection
 *
 * Usage:
 * <button (undetected.click)="handleClick()"></button>
 *
 * ...
 *
 * export class ExampleComponent implements OnInit {
 *
 *  constructor(private zone: NgZone) {}
 *
 *  handleClick() {
 *      if(someCondition) {
 *          this.zone.run(() => {
 *              ...
 *          });
 *      }
 *  }
 * }
 *
 */
var UndetectedEventPlugin = (function (_super) {
    __extends(UndetectedEventPlugin, _super);
    function UndetectedEventPlugin(doc) {
        return _super.call(this, doc) || this;
    }
    UndetectedEventPlugin.prototype.supports = function (eventName) {
        return eventName.indexOf('undetected.') === 0;
    };
    UndetectedEventPlugin.prototype.addEventListener = function (element, eventName, handler) {
        var _this = this;
        var realEventName = eventName.slice(11);
        return this.manager.getZone().runOutsideAngular(function () {
            return _this.manager.addEventListener(element, realEventName, handler);
        });
    };
    return UndetectedEventPlugin;
}(event_manager_plugin_1.MyEventManagerPlugin));
UndetectedEventPlugin.decorators = [
    { type: core_1.Injectable },
];
/** @nocollapse */
UndetectedEventPlugin.ctorParameters = function () { return [
    { type: undefined, decorators: [{ type: core_1.Inject, args: [platform_browser_1.DOCUMENT,] },] },
]; };
exports.UndetectedEventPlugin = UndetectedEventPlugin;
